(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/rate', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].rate = {}), global.ng.core, global.ng.forms, global.ng.common));
}(this, (function (exports, core, forms, common) { 'use strict';

    var NelRateComponent = /** @class */ (function () {
        function NelRateComponent() {
            this.nelColors = ['#F7BA2A', '#F7BA2A', '#F7BA2A'];
            this.data = null;
            this.currentValue = -1;
            this.starArray = [0, 1, 2, 3, 4];
            this.change = function (val) { };
        }
        NelRateComponent.prototype.handleHover = function (value) {
            this.currentValue = value;
        };
        NelRateComponent.prototype.handleClick = function (value) {
            this.data = value;
        };
        NelRateComponent.prototype.writeValue = function (val) {
            this.data = val;
        };
        NelRateComponent.prototype.registerOnChange = function (fn) {
            this.change = fn;
        };
        NelRateComponent.prototype.registerOnTouched = function (fn) { };
        return NelRateComponent;
    }());
    NelRateComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-rate',
                    template: "<div class=\"el-rate\" role=\"slider\" aria-valuetext=\"\" aria-valuemin=\"0\" aria-valuemax=\"5\" tabindex=\"0\" aria-valuenow=\"0\">\r\n  <nel-rate-item *ngFor=\"let item of starArray; let index=index\" [data]=\"index\" [currentValue]=\"currentValue\"\r\n    [value]=\"data\" [colors]=\"nelColors\" (onHover)=\"handleHover($event)\" (onClick)=\"handleClick($event)\"></nel-rate-item>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return NelRateComponent; }),
                            multi: true
                        }
                    ]
                },] }
    ];
    NelRateComponent.propDecorators = {
        nelColors: [{ type: core.Input }]
    };

    var NelRateItemComponent = /** @class */ (function () {
        function NelRateItemComponent() {
            // 鼠标当前move的下标
            this.currentValue = -1;
            // 当前选择的评分
            this.value = null;
            this.data = 0;
            this.onHover = new core.EventEmitter();
            this.onClick = new core.EventEmitter();
        }
        NelRateItemComponent.prototype.handleMouseover = function () {
            this.onHover.emit(this.data);
        };
        NelRateItemComponent.prototype.handleMouseleave = function () {
            this.onHover.emit(-1);
        };
        NelRateItemComponent.prototype.handleClick = function () {
            this.onClick.emit(this.data);
        };
        NelRateItemComponent.prototype.getOn = function () {
            return this.data <= this.currentValue
                || (this.currentValue === -1 && this.value !== null && this.data <= this.value);
        };
        NelRateItemComponent.prototype.getHover = function () {
            return this.data <= this.currentValue;
        };
        NelRateItemComponent.prototype.getColor = function () {
            var value = this.currentValue !== -1 ? this.currentValue : this.value ? this.value : -1;
            var color = 'rgb(198, 209, 222)';
            var colorItem = this.color.find(function (item) { return value <= item.key; });
            if (colorItem) {
                color = colorItem.value;
            }
            return this.getOn() ? color : 'rgb(198, 209, 222)';
        };
        NelRateItemComponent.prototype.ngOnChanges = function (changes) {
            var colors = changes.colors;
            if (colors) {
                var colorList = [];
                if (colors instanceof Array) {
                    colorList = [
                        { key: 2, value: '#F7BA2A' },
                        { key: 4, value: '#F7BA2A' },
                        { key: 5, value: '#F7BA2A' },
                    ];
                }
                else {
                    for (var key in colors.currentValue) {
                        colorList.push({
                            key: Number(key),
                            value: colors.currentValue[key]
                        });
                    }
                }
                colorList.sort(function (a, b) {
                    return a.key - b.key;
                });
                this.color = colorList;
            }
        };
        return NelRateItemComponent;
    }());
    NelRateItemComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-rate-item',
                    template: "<span class=\"el-rate__item\" style=\"cursor: pointer;\" (mouseover)=\"handleMouseover()\" (mouseleave)=\"handleMouseleave()\"\r\n  (click)=\"handleClick()\">\r\n  <i class=\"el-rate__icon\" [class.el-icon-star-off]=\"!getOn()\" [class.el-icon-star-on]=\"getOn()\"\r\n    [class.hover]=\"getHover()\" [style.color]=\"getOn() ? 'rgb(247, 186, 42)' : 'rgb(198, 209, 222)'\"></i>\r\n</span>\r\n"
                },] }
    ];
    NelRateItemComponent.propDecorators = {
        currentValue: [{ type: core.Input }],
        value: [{ type: core.Input }],
        data: [{ type: core.Input }],
        colors: [{ type: core.Input }],
        onHover: [{ type: core.Output }],
        onClick: [{ type: core.Output }]
    };

    var NelRateModule = /** @class */ (function () {
        function NelRateModule() {
        }
        return NelRateModule;
    }());
    NelRateModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelRateComponent,
                        NelRateItemComponent
                    ],
                    exports: [
                        NelRateComponent,
                        NelRateItemComponent
                    ],
                    imports: [
                        common.CommonModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelRateComponent = NelRateComponent;
    exports.NelRateModule = NelRateModule;
    exports.ɵa = NelRateItemComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-rate.umd.js.map
