import { ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BooleanInput } from '@angular/cdk/coercion';
export declare type SizeType = 'medium' | 'small' | 'mini' | null;
export declare class NelInputComponent implements ControlValueAccessor, OnChanges {
    private cdr;
    static ngAcceptInputType_nelDisabled: BooleanInput;
    static ngAcceptInputType_nelClearable: BooleanInput;
    static ngAcceptInputType_nelShowPassword: BooleanInput;
    nelPlaceHolder: string;
    nelDisabled: boolean;
    nelClearable: boolean;
    nelShowPassword: boolean;
    nelSize: SizeType;
    onClear: EventEmitter<void>;
    inputEle: ElementRef;
    data: any;
    focused: boolean;
    hovering: boolean;
    type: string;
    change: (val: any) => void;
    constructor(cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    onInput($event: any): void;
    handleBlur(): void;
    handleFocus(): void;
    handleClear(): void;
    handleMouseEnter(): void;
    handleMouseLeave(): void;
    changeType(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
